import requests
import json
from oraculum.utils import schedule

# FIXME - make it possible to use qa.fp.o/blockerbugs directly
BLOCKERBUGS_URL = "http://37.205.11.174:8080/api/v0/milestones/%d/%s/bugs"

def get_blockerbugs():
    data = {
        "beta_blockers": "NaN",
        "beta_blockers_proposed": "NaN",
        "beta_fe": "NaN",
        "beta_fe_proposed": "NaN",
        "final_blockers": "NaN",
        "final_blockers_proposed": "NaN",
        "final_fe": "NaN",
        "final_fe_proposed": "NaN"
    }
    release = schedule.current_devel()

    try:
        resp_beta = requests.get(BLOCKERBUGS_URL % (release, "beta"))
        resp_final = requests.get(BLOCKERBUGS_URL % (release, "final"))
    except:
        return data

    beta_blockers, beta_fe, final_blockers, final_fe = (0, 0, 0, 0)
    beta_blockers_prop, beta_fe_prop, final_blockers_prop, final_fe_prop = (0, 0, 0, 0)

    if resp_beta.status_code != 200 or resp_final.status_code != 200:
        return data

    bugs_list = json.loads(resp_beta.text)
    for bug in bugs_list:
        if not (bug["active"]):
            continue
        if "accepted_blocker" in bug["type"]:
            beta_blockers += 1
        if "proposed_blocker" in bug["type"]:
            beta_blockers_prop += 1
        if "accepted_fe" in bug["type"]:
            beta_fe += 1
        if "proposed_fe" in bug["type"]:
            beta_fe_prop += 1

    bugs_list = json.loads(resp_final.text)
    for bug in bugs_list:
        if not (bug["active"]):
            continue
        if "accepted_blocker" in bug["type"]:
            final_blockers += 1
        if "proposed_blocker" in bug["type"]:
            final_blockers_prop += 1
        if "accepted_fe" in bug["type"]:
            final_fe += 1
        if "proposed_fe" in bug["type"]:
            final_fe_prop += 1

    data = {
        "beta_blockers": beta_blockers,
        "beta_blockers_proposed": beta_blockers_prop,
        "beta_fe": beta_fe,
        "beta_fe_proposed": beta_fe_prop,
        "final_blockers": final_blockers,
        "final_blockers_proposed": final_blockers_prop,
        "final_fe": final_fe,
        "final_fe_proposed": final_fe_prop
    }

    return data
