import requests
from lxml import html

URL = "https://meetbot-raw.fedoraproject.org/teams/fedora-qa/"

def get_last_qa_meeting():
    resp = requests.get(URL)
    data = {}

    if resp.status_code == 200:
        tree = html.fromstring(resp.text)
        all_minutes = tree.xpath('//a[re:match(text(),"(?<!log)\.html")]',
                                 namespaces={"re":"http://exslt.org/regular-expressions"})
        latest_minutes = all_minutes[-1].attrib['href']
        date_raw = latest_minutes.lstrip('fedora-qa.').rstrip('.html')

        data = {
            'link': URL + latest_minutes,
            'date': date_raw # FIXME better format
        }

    return data
    